/*
   Copyright 2009-2010 IEAP CTU
   Author: Daniel Turecek (daniel.turecek@utef.cvut.cz)
 */
package cz.ieap.jplugininterface.structs;

/**
 * Class for storing values from ExtFilterChainInfo structure in pixelman
 * structure to get information about certain FilterChain
 * @author Daniel Turecek
 */
public class ExtFilterChainInfo {

    public long filterChainID = 0;           // id of the filter chain. Filled when called by function getFilterChainsList
    public String pluginName = "";          // plugin which created filter chain
    public String filterChainName = "";     // filter chain name
    public long[] filterIDs = null;         // pointer to buffer (provided by user) to obtain IDs of filters which are in chain, can be NULL if caller do not want this info
    public long filterIDsSize = 0;          // size of filterIDs buffer
    public String filterNames = "";         // pointer to buffer (provided by user) to obtain names of filters which are in chain (separated by '|'), can be NULL if caller do not want this info
    public long filterNamesSize = 0;        // size of filterNames buffer
    
    public ExtFilterChainInfo(){
        
    }


    @Override
    public String toString(){
        return "[PluginName: "+pluginName+", filterChainName: "+filterChainName+", FiterIDsSize: "+filterIDsSize
		+ ", FilterNames: "+ filterNames+", filterNamesSize: "+filterNamesSize+"]";
    }


    public String[] getFilterNames(){
        return filterNames.split("\\|");
    }
}
