/*
   Copyright 2009-2010 IEAP CTU
   Author: Daniel Turecek (daniel.turecek@utef.cvut.cz)
 */
package cz.ieap.jplugininterface.structs;

import java.nio.ByteBuffer;

/**
 * Class to store ItemInfo structure data
 * @author Daniel Turecek
 */
public class ItemInfo {
    public int type;            // variable type
    public long count;          // Buffer size  - must always match real size of buffer. especially if sending throu some function in pixelman
    public long flags;          // combination of flags (e.g. for HwInfoItem MPX_HWINFO_* flags)
    public String name = "";    // name of item
    public String descr = "";   // item description
    public ByteBuffer data;     // pointer to variable of described type

    public ItemInfo(){
        count = 0;
    }

    public ItemInfo(int bufferSize){
        data = ByteBuffer.allocateDirect(bufferSize);
        count = bufferSize;
    }

    @Override
    public String toString(){
        return "[ type: "+type+", count: "+count+", flags: "+flags+", name: "+name+", descr: "+descr+"]";
    }
}
