/*
   Copyright 2009-2010 IEAP CTU
   Author: Daniel Turecek (daniel.turecek@utef.cvut.cz)
 */
package cz.ieap.jplugininterface.structs;

/**
 * Mpx erros definition class
 * @author Daniel Turecek
 */
public class MpxErrors {

//******************************************************************************
// CONSTANTS
//******************************************************************************

    // common errors
    /**  success */
    public final static int MPXERR_NOERROR                                = 0;
    /**  unexpected error */
    public final static int MPXERR_UNEXPECTED                             = -1;
    /**  invalid param supplied */
    public final static int MPXERR_INVALID_PARVAL                         = -2;
    /**  memory allocation error */
    public final static int MPXERR_MEMORY_ALLOC                           = -3;
    /**  supplied buffer is too small */
    public final static int MPXERR_BUFFER_SMALL                           = -4;
    /**  cannot open file for reading */
    public final static int MPXERR_FILE_OPENREAD                          = -5;
    /**  cannot open file for writing */
    public final static int MPXERR_FILE_OPENWRITE                         = -6;
    /**  error while reading file */
    public final static int MPXERR_FILE_READ                              = -7;
    /**  error while writing to file */
    public final static int MPXERR_FILE_WRITE                             = -8;
    /**  invalid value was read from file */
    public final static int MPXERR_FILE_BADDATA                           = -9;
    /**  timeout while waiting for synchronization object */
    public final static int MPXERR_LOCK_TIMEOUT                           = -10;
    /**  failed to unlock sync object (caller is not lock owner; */
    public final static int MPXERR_UNLOCK                                 = -11;

    // mpxctrl layer generic errors
    /**  mpxctrl layer is not initialized */
    public final static int MPXERR_MPXCTRL_NOTINIT                        = -100;
    /**  no hardware library was found */
    public final static int MPXERR_NOHWLIBFOUND                           = -101;
    /**  supplied DEVID is not valid (no assigned Medipix device; */
    public final static int MPXERR_IDINVALID                              = -102;
    /**  failed to load one of HW library */
    public final static int MPXERR_LOADHWLIB                              = -103;
    /**  initialization of hw library error */
    public final static int MPXERR_HWLIBINIT                              = -104;


    // mpxctrl layer device-specific errors
    /**  device is not properly initialized */
    public final static int MPXERR_MPXDEV_NOTINIT                         = -110;
    /**  open cfg file failed */
    public final static int MPXERR_OPENCFG                                = -111;
    /**  errors occurred while reading/parsing cfg file */
    public final static int MPXERR_READCFG                                = -112;
    /**  setting interface-specific info failed */
    public final static int MPXERR_HWINFO_SETITEM                         = -113;
    /**  getting interface-specific info failed */
    public final static int MPXERR_HWINFO_GETITEM                         = -114;
    /**  required frame is not ready  */
    public final static int MPXERR_FRAME_NOTREADY                         = -115;

    /**  fail to start acquisition */
    public final static int MPXERR_ACQSTART                               = -150;
    /**  fail to stop acquisition */
    public final static int MPXERR_ACQSTOP                                = -151;
    /**  acq aborted */
    public final static int MPXERR_ACQABORTED                             = -152;
    /**  fail to check busy state */
    public final static int MPXERR_CHECK_BUSY                             = -153;
    /**  read matrix failed */
    public final static int MPXERR_READMATRIX                             = -154;
    /**  write matrix failed */
    public final static int MPXERR_WRITEMATRIX                            = -155;
    /**  reset matrix failed */
    public final static int MPXERR_RESETMATRIX                            = -156;
    /**  test pulses sending failed */
    public final static int MPXERR_TESTPULSES                             = -157;
    /**  setting mask (pix. configuration; failed */
    public final static int MPXERR_SETMASK                                = -158;
    /**  failed to sense DAC analog value */
    public final static int MPXERR_READANALOGDAC                          = -159;
    /**  failed to set DACs */
    public final static int MPXERR_SETDACS                                = -160;
    /**  stream to data conversion error */
    public final static int MPXERR_CONVSTREAM2DATA                        = -161;
    /**  data to stream conversion error */
    public final static int MPXERR_CONVDATA2STREAM                        = -162;
    /**  error converting pseudorandom counter values */
    public final static int MPXERR_CONVPSEUDO                             = -163;
    /**  failed to set external DAC */
    public final static int MPXERR_SETEXTDAC                              = -164;
    /**  invalid operation (operation cannot be performed; */
    public final static int MPXERR_INVALIDOP                              = -165;


    // frame errors
    /**  frame with specified ID does not exist */
    public final static int MPXERR_FRAME_NOTEXIST                         = -200;
    /**  frame was not properly initialized */
    public final static int MPXERR_FRAME_NOTINIT                          = -201;
    /**  attribute was not found */
    public final static int MPXERR_ATTRIB_NOTFOUND                        = -202;
    /**  attribute already exists */
    public final static int MPXERR_ATTRIB_EXISTS                          = -203;
    /**  invalid size of frame */
    public final static int MPXERR_INVALID_SIZE                           = -204;
    /**  invalid format of data file */
    public final static int MPXERR_DATAFILE_FORMAT                        = -205;
    /**  invalid format of description file */
    public final static int MPXERR_DESCFILE_FORMAT                        = -206;
    /**  cannot close frame, frame is protected */
    public final static int MPXERR_CLOSE_PROTECT                          = -207;
    /**  filter function failed */
    public final static int MPXERR_FILTER_FAILED                          = -208;


    // mpxmgr errors
    /**  referenced plugin is not registered */
    public final static int MPXERR_PLUGIN_NOTEXIST                        = -300;
    /**  function is already registered by this plugin */
    public final static int MPXERR_FUNC_ALREADYREG                        = -301;
    /**  function is not registered by this plugin */
    public final static int MPXERR_FUNC_NOTEXIST                          = -302;
    /**  menu item already exists */
    public final static int MPXERR_MENUITEM_ALREADYREG                    = -303;
    /**  specified menu item is not registered */
    public final static int MPXERR_MENUITEM_NOTEXIST                      = -304;
    /**  event is already registered by this plugin */
    public final static int MPXERR_EVENT_ALREADYREG                       = -305;
    /**  event is not registered by this plugin */
    public final static int MPXERR_EVENT_NOTEXIST                         = -306;
    /**  frame attribute template is already registered by this plugin */
    public final static int MPXERR_FRAMEATTR_ALREADYREG                   = -307;
    /**  frame attribute template with this name is not registered */
    public final static int MPXERR_FRAMEATTR_NOTEXIST                     = -308;
    /**  filter chain is already registered by this plugin */
    public final static int MPXERR_FILTCHAIN_ALREADYREG                   = -309;
    /**  specified filter chain does not exist */
    public final static int MPXERR_FILTCHAIN_NOTEXIST                     = -310;
    /**  instance of filter with specified name already exists */
    public final static int MPXERR_FILTERINST_EXIST                       = -311;

    // server errors
    public final static int MPXERR_SRV_CANT_CONNECT                       = -400;
    public final static int MPXERR_SRV_NOTCONNECTED                       = -401;
    public final static int MPXERR_SRV_TIMEOUT                            = -402;
    public final static int MPXERR_SRV_TCPERROR                           = -403;
    public final static int MPXERR_SRV_BUFFSMALL                          = -404;
    public final static int MPXERR_SRV_INVALIDRESP                        = -405;
    public final static int MPXERR_SRV_INVALIDLOGIN                       = -406;
    public final static int MPXERR_SRV_NOTLOGGED                          = -407;
    public final static int MPXERR_SRV_INVALIDSESSION                     = -408;
    public final static int MPXERR_SRV_NOTFOUND                           = -409;
    public final static int MPXERR_SRV_INVALID_COMMAND                    = -410;
    public final static int MPXERR_SRV_INVALID_PARAMCNT                   = -411;
    public final static int MPXERR_SRV_INVALID_PARAM                      = -412;

    // calibration errors
    public final static int MPXERR_CALIB_NOTFOUND                         = -500;
    public final static int MPXERR_CALIB_UNKNOWNTYPE                      = -501;
    public final static int MPXERR_CALIB_INVALID_MATRIX_CNT               = -502;
    public final static int MPXERR_CALIB_INVALID                          = -503;


    public static String getMessage(final int errorCode) {
        switch (errorCode) {
            case -1: return "Unexpected error";
            case -2: return "Invalid param supplied";
            case -3: return "Memory allocation error";
            case -4: return "Supplied buffer is too small";
            case -5: return "Cannot open file for reading";
            case -6: return "Cannot open file for writing";
            case -7: return "Error while reading file";
            case -8: return "Error while writing to file";
            case -9: return "Invalid value was read from file";
            case -10: return "Timeout while waiting for synchronization object";
            case -11: return "Failed to unlock sync object (caller is not lock owner)";
            case -12: return "Failed to locate file";
            case -13: return "Seek failed";

            // mpxctrl layer generic errors
            case -100: return "Mpxctrl layer is not initialized";
            case -101: return "No hardware library was found";
            case -102: return "Supplied DEVID is not valid (no assigned Medipix device)";
            case -103: return "Failed to load one of HW library";
            case -104: return "Initialization of hw library error";

            // mpxctrl layer device-specific errors
            case -110: return "Device is not properly initialized";
            case -111: return "Open cfg file failed";
            case -112: return "Errors occurred while reading/parsing cfg file";
            case -113: return "Setting interface-specific info failed";
            case -114: return "Getting interface-specific info failed";
            case -115: return "Required frame is not ready";

            case -120: return "Confg item not found";
            case -121: return "Confg item allready exists";

            case -150: return "Fail to start acquisition";
            case -151: return "Fail to stop acquisition";
            case -152: return "Acq aborted";
            case -153: return "Fail to check busy state";
            case -154: return "Read matrix failed";
            case -155: return "Write matrix failed";
            case -156: return "Reset matrix failed";
            case -157: return "Test pulses sending failed";
            case -158: return "Setting mask (pix. configuration) failed";
            case -159: return "Failed to sense DAC analog value";
            case -160: return "Failed to set DACs";
            case -161: return "Stream to data conversion error";
            case -162: return "Data to stream conversion error";
            case -163: return "Error converting pseudorandom counter values";
            case -164: return "Failed to set external DAC";
            case -165: return "Invalid operation (operation cannot be performed)";

            // frame errors
            case -200: return "Frame with specified ID does not exist";
            case -201: return "Frame was not properly initialized";
            case -202: return "Attribute was not found";
            case -203: return "Attribute already exists";
            case -204: return "Invalid size of frame";
            case -205: return "Invalid format of data file";
            case -206: return "Invalid format of description file";
            case -207: return "Cannot close frame, frame is protected";
            case -208: return "Filter function failed";
            case -209: return "Inconsistence of read/parsed data detected";

            // mpxmgr errors
            case -300: return "Referenced plugin is not registered";
            case -301: return "Function is already registered by this plugin";
            case -302: return "Function is not registered by this plugin";
            case -303: return "Menu item already exists";
            case -304: return "Specified menu item is not registered";
            case -305: return "Event is already registered by this plugin";
            case -306: return "Event is not registered by this plugin";
            case -307: return "Frame attribute template is already registered by this plugin";
            case -308: return "Frame attribute template with this name is not registered";
            case -309: return "Filter chain is already registered by this plugin";
            case -310: return "Specified filter chain does not exist";
            case -311: return "Instance of filter with specified name already exists";

            // server errors
            case -400: return "MPXERR_SRV_CANT_CONNECT";
            case -401: return "MPXERR_SRV_NOTCONNECTED";
            case -402: return "MPXERR_SRV_TIMEOUT";
            case -403: return "MPXERR_SRV_TCPERROR";
            case -404: return "MPXERR_SRV_BUFFSMALL";
            case -405: return "MPXERR_SRV_INVALIDRESP";
            case -406: return "MPXERR_SRV_INVALIDLOGIN";
            case -407: return "MPXERR_SRV_NOTLOGGED";
            case -408: return "MPXERR_SRV_INVALIDSESSION";
            case -409: return "MPXERR_SRV_NOTFOUND";
            case -410: return "MPXERR_SRV_INVALID_COMMAND";
            case -411: return "MPXERR_SRV_INVALID_PARAMCNT";
            case -412: return "MPXERR_SRV_INVALID_PARAM";

            // calibration errors
            case -500: return "MPXERR_CALIB_NOTFOUND";
            case -501: return "MPXERR_CALIB_UNKNOWNTYPE";
            case -502: return "MPXERR_CALIB_INVALID_MATRIX_CNT";
            case -503: return "MPXERR_CALIB_INVALID";

            case 1: return "Info message";
                
            default: return "Unkowen errorCode";
         }
    }
}
